
////////////////////////////////////////////////////////////////////////////////////////

export function removeInject(dimension, loc1, loc2) {
  [loc1, loc2].forEach(loc => dimension.setBlockType(loc, "air"));
}

////////////////////////////////////////////////////////////////////////////////////////

export function signToEntityRot(signRot) {
  if (signRot < 0 || signRot > 15) return null; // Validate input range
  const entityRot = (signRot <= 8 ? signRot : signRot - 16) * 22.5;
  return entityRot;
}

////////////////////////////////////////////////////////////////////////////////////////

export function signToBlockRot(signRot) {
  if (signRot < 0 || signRot > 15) return "invalid"; // Validate input range
  const directions = {
    0: "south",
    4: "west",
    8: "north",
    12: "east",
  };
  return directions[signRot] || "invalid";
}

////////////////////////////////////////////////////////////////////////////////////////

export function formatSignText(rawText) {
  // Trim whitespace from the input string
  const trimmedText = rawText.trim();
  const lines = trimmedText.split("\n");
  return {
    ln0: lines[0] || "", // First line or empty if missing
    ln1: lines[1] || "", // Second line or empty if missing
    ln2: lines[2] || "", // Third line or empty if missing
    ln3: lines[3] || "", // Fourth line or empty if missing
  };
}

////////////////////////////////////////////////////////////////////////////////////////