////////////////////////////////////////////////////////////////////////////////////////
// File: scripts/item_components.js
// Usage: custom item components
////////////////////////////////////////////////////////////////////////////////////////

import * as meleeSpAtk from "./weapons/melee.js";
import * as rangedSpAtk from "./weapons/ranged.js";
import * as throwableSpAtk from "./weapons/throwable.js";
import * as usableSpAtk from "./weapons/usable.js";

////////////////////////////////////////////////////////////////////////////////////////

export const specialAttackHandler = {
  onUse(event) {
    const handlers = {
      // melee special attack handlers
      "sbs_mw:armadillo_drill": meleeSpAtk.armadilloDrill,
      "sbs_mw:bee_blades": meleeSpAtk.beeBlades,
      "sbs_mw:cave_spider_sword": meleeSpAtk.caveSpiderSword,
      "sbs_mw:creaking_dagger": meleeSpAtk.creakingDagger,
      "sbs_mw:drowned_trident": meleeSpAtk.drownedTrident,
      "sbs_mw:ender_dragon_sword": meleeSpAtk.enderDragonSword,
      "sbs_mw:iron_golem_hammer": meleeSpAtk.ironGolemHammer,
      "sbs_mw:piglin_sword": meleeSpAtk.piglinSword,
      "sbs_mw:polar_bear_claw": meleeSpAtk.polarBearClaw,
      "sbs_mw:ravager_punch": meleeSpAtk.ravagerPunch,
      "sbs_mw:salmon_sword": meleeSpAtk.salmonSword,
      "sbs_mw:vex_sword": meleeSpAtk.vexSword,
      "sbs_mw:vindicator_axe": meleeSpAtk.vindicatorAxe,
      "sbs_mw:wither_scythe": meleeSpAtk.witherScythe,
      "sbs_mw:zombie_hand": meleeSpAtk.zombieHand,
      "sbs_mw:breeze_staff": meleeSpAtk.breezeStaff,
      // ranged weapon handlers
      "sbs_mw:witch_wand": rangedSpAtk.witchWand,
      "sbs_mw:creeper_cannon": rangedSpAtk.creeperCannon,
      "sbs_mw:enderman_phaser": rangedSpAtk.endermanPhaser,
      "sbs_mw:blaze_flamethrower": rangedSpAtk.blazeFlamethrower,
      "sbs_mw:ghast_blaster": rangedSpAtk.ghastBlaster,
      "sbs_mw:spider_net": rangedSpAtk.spiderNet,
      "sbs_mw:llama_spitter": rangedSpAtk.llamaSpitter,
      "sbs_mw:magma_flooder": rangedSpAtk.magmaFlooder,
      // "sbs_mw:warden_sonic_blaster": rangedSpAtk.wardenSonicBlaster,
      "sbs_mw:skeleton_bow": rangedSpAtk.skeletonBow,
      "sbs_mw:bogged_bow": rangedSpAtk.boggedBow,
      "sbs_mw:pillager_crossbow": rangedSpAtk.pillagerCrossbow,
      "sbs_mw:stray_bow": rangedSpAtk.strayBow,
      // throwable weapons handlers
      "sbs_mw:chicken_bomb": throwableSpAtk.chickenBomb,
      "sbs_mw:slime_jar": throwableSpAtk.slimeJar,
      "sbs_mw:pig_mudder": throwableSpAtk.pigMudder,
      // usable weapon handlers
      "sbs_mw:goat_helmet": usableSpAtk.goatHelmet,
    };
    // Attempt to call the handler
    handlers[event.itemStack.typeId]?.(event);
  }
}
