
//////////////////////////////////////////////////////////////////////////////////////////////////

// MELEE PROJECTILES ON HIT

export function caveSpiderSword(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`setblock ~ ~ ~ web [] replace`);
    hitEntity.runCommand(`effect @s poison 3 0 false`);
    hitEntity.runCommand(`particle sbs_mw:cave_spider_sword_hit ~ ~ ~`);
  } catch { }
}

export function drownedTrident(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`particle sbs_mw:drowned_trident_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.drowned_trident_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function vindicatorAxe(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`particle sbs_mw:vindicator_axe_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.vindicator_axe_hit_sound @a[r=16] ~ ~ ~ 2 1`);
  } catch { }
}

//////////////////////////////////////////////////////////////////////////////////////////////////

// RANGED PROJECTILES ON HIT
export function blazeFlamethrower(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`scriptevent sbs_mw:create_explosion 4,false,false`);
    hitEntity.runCommand(`particle sbs_mw:blaze_flamethrower_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.blaze_flamethrower_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function boggedBow(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`scriptevent sbs_mw:create_explosion 4,true,false`);
    hitEntity.runCommand(`particle sbs_mw:bogged_bow_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.bogged_bow_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function creeperCannon(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`scriptevent sbs_mw:create_explosion 8,false,false`);
    hitEntity.runCommand(`particle sbs_mw:creeper_cannon_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.creeper_cannon_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function endermanPhaser(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`scriptevent sbs_mw:random_tp 10`);
    hitEntity.runCommand(`particle sbs_mw:enderman_phaser_hit ~ ~ ~`);
    hitEntity.runCommand(`summon sbs_mw:enderman_phaser_util ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.enderman_phaser_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function ghastBlaster(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`scriptevent sbs_mw:create_explosion 8,false,false`);
    hitEntity.runCommand(`particle sbs_mw:ghast_blaster_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.ghast_blaster_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function llamaSpitter(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`effect @s slowness 5 0 false`);
    hitEntity.runCommand(`particle sbs_mw:llama_spitter_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.llama_spitter_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function magmaFlooder(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`fill ~-1~-1~-1 ~1~1~1 fire replace air`);
    hitEntity.runCommand(`effect @s poison 3 0 false`);
    hitEntity.runCommand(`particle sbs_mw:magma_flodder_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.magma_flodder_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function pillagerCrossbow(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`particle sbs_mw:pillager_crossbow_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.pillager_crossbow_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function skeletonBow(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`particle sbs_mw:skeleton_bow_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.skeleton_bow_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function spiderNet(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`fill ~-1~-1~-1 ~1~2~1 web replace air`);
    hitEntity.runCommand(`effect @s poison 3 0 false`);
    hitEntity.runCommand(`particle sbs_mw:spider_net_hit ~ ~ ~`);
  } catch { }
}

export function strayBow(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`fill ~-1~-1~-1 ~1~2~1 powder_snow replace air`);
    hitEntity.runCommand(`particle sbs_mw:stray_bow_hit ~ ~ ~`);
  } catch { }
}

export function witchWand(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`particle sbs_mw:witch_wand_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.witch_wand_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function wardenSonicBlaster(event) {
  const hitEntity = event.getEntityHit()?.entity;
  const strengthMapping = {
    "sbs_mw:warden_sonic_blaster_projectile1": 3.8,
    "sbs_mw:warden_sonic_blaster_projectile2": 5.8,
    "sbs_mw:warden_sonic_blaster_projectile3": 7.8,
  };
  const verticalMultiplierMapping = {
    "sbs_mw:warden_sonic_blaster_projectile1": 1,
    "sbs_mw:warden_sonic_blaster_projectile2": 2,
    "sbs_mw:warden_sonic_blaster_projectile3": 3,
  };
  const strength = strengthMapping[event.projectile.typeId];
  const verticalMultiplier = verticalMultiplierMapping[event.projectile.typeId];
  try {
    hitEntity.applyKnockback(event.hitVector.x, event.hitVector.z, strength, event.hitVector.y * 1.45 + verticalMultiplier);
    hitEntity.runCommand(`particle sbs_mw:warden_sonic_blaster_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.warden_sonic_blaster_hit_sound @a[r=16] ~ ~ ~`);
  } catch (err) {
    console.log(`KNOCKBACK ERROR :: ${err}`);
  }
}

//////////////////////////////////////////////////////////////////////////////////////////////////

// THROWABLE PROJECTILES ON HIT

export function chickenBomb(event) {
  const hitEntity = event.getEntityHit()?.entity;
  const dim = hitEntity.dimension;
  const loc = hitEntity.location;
  loc.y = loc.y + 4;
  try {
    hitEntity.runCommand(`scriptevent sbs_mw:create_explosion 4,true,false`);
    hitEntity.runCommand(`particle sbs_mw:chicken_bomb_shoot ~ ~ ~`);
    hitEntity.runCommand(`particle minecraft:huge_explosion_emitter ~ ~ ~`);
    hitEntity.runCommand(`particle sbs_mw:chicken_bomb_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.chicken_bomb_hit_sound @a[r=16] ~ ~ ~`);
    system.runTimeout(spawnChicken(dim, loc), 5)
  } catch { }
}

export function pigMudder(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`summon pig ~~~`);
    hitEntity.runCommand(`summon sbs_mw:pig_mudder_utility ~ ~ ~`);
    hitEntity.runCommand(`effect @e[r=3] slowness 10 0 false`);
    hitEntity.runCommand(`particle sbs_mw:pig_mudder_hit ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.pig_mudder_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

export function slimeJar(event) {
  const hitEntity = event.getEntityHit()?.entity;
  try {
    hitEntity.runCommand(`summon sbs_mw:slime_jar_utility ~ ~ ~`);
    hitEntity.runCommand(`playsound sbs_mw.slime_jar_hit_sound @a[r=16] ~ ~ ~`);
  } catch { }
}

//////////////////////////////////////////////////////////////////////////////////////////////////
