
// main imports
import { EquipmentSlot } from "@minecraft/server";

// features
import * as util from "./util.js";


// animations
const abilityAnimation = {
  chickenBomb: "animation.sbs_mw.chicken_bomb.player.tp_ability",
  slimeJar: "animation.sbs_mw.slime_jar.player.tp_ability",
  pigMudder: "animation.sbs_mw.pig_mudder.player.tp_ability",
}

////////////////////////////////////////////////////////////////////////////////////////////////////
// Special attack for throwable weapons
////////////////////////////////////////////////////////////////////////////////////////////////////

export function chickenBomb(event) {
  const player = event.source;
  player.runCommand(`scoreboard players set @s sbs_mw_playerTpAnimStep 10`);
  player.runCommand(`scoreboard players set @s sbs_mw_playerTpAnimTick 12`);
  player.runCommand(`playanimation @s ${abilityAnimation.chickenBomb} default 0 "v.is_first_person"`);
  util.throwProjectile("sbs_mw:chicken_bomb_projectile", player,1.25);
  player.runCommand(`playsound sbs_mw.chicken_bomb_throw @a[r=10] ~ ~ ~ 1 1`);
  player.runCommand(`playsound sbs_mw.chicken.shoot @a[r=10] ~ ~ ~ 1 1`);
  player.runCommand(`clear @s sbs_mw:chicken_bomb -1 1`);
}

////////////////////////////////////////////////////////////////////////////////////////////////////

export function slimeJar(event) {
  const player = event.source;
  player.runCommand(`scoreboard players set @s sbs_mw_playerTpAnimStep 10`);
  player.runCommand(`scoreboard players set @s sbs_mw_playerTpAnimTick 12`);
  player.runCommand(`playanimation @s ${abilityAnimation.slimeJar} default 0 "v.is_first_person"`);
  util.throwProjectile("sbs_mw:slime_jar_projectile", player,1.25);
  player.runCommand(`playsound sbs_mw.slime_jar_shoot @a[r=10] ~ ~ ~ 1 1`);
  player.runCommand(`clear @s sbs_mw:slime_jar -1 1`);
}

////////////////////////////////////////////////////////////////////////////////////////////////////

export function pigMudder(event) {
  const player = event.source;
  player.runCommand(`scoreboard players set @s sbs_mw_playerTpAnimStep 10`);
  player.runCommand(`scoreboard players set @s sbs_mw_playerTpAnimTick 12`);
  player.runCommand(`playanimation @s ${abilityAnimation.pigMudder} default 0 "v.is_first_person"`);
  util.throwProjectile("sbs_mw:pig_mudder_projectile", player,1.25);
  player.runCommand(`playsound sbs_mw.pig_mudder.shoot @a[r=10] ~ ~ ~ 1 1`);
  player.runCommand(`clear @s sbs_mw:pig_mudder -1 1`);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
